/***************************************************************************
 *   Copyright (C) 2004 by Cyril Bosselut                                  *
 *   bosselut@b1project.com                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "ktag.h"
#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>
#include <kdebug.h>
#include <kfiledialog.h>
#include <qfileinfo.h>

static const char description[] =
    I18N_NOOP("A KDE audio tag editor");

static const char version[] = "0.1";

static KCmdLineOptions options[] =
{
    { "+[URL]", I18N_NOOP( "Document to open." ), 0 },
    KCmdLineLastOption
};

int main(int argc, char **argv)
{
    KAboutData about("ktag", I18N_NOOP("Ktag"), version, description,
                     KAboutData::License_GPL, "(C) 2004 Cyril Bosselut", 0, 0, "bosselut@b1project.com");
    about.addAuthor( "Cyril Bosselut", 0, "bosselut@b1project.com" );
    KCmdLineArgs::init(argc, argv, &about);
    KCmdLineArgs::addCmdLineOptions( options );
    KApplication app;
    Ktag *mainWin = 0;

        // no session.. just start up normally
        KCmdLineArgs *args = KCmdLineArgs::parsedArgs();

        /// @todo do something with the command line args here

        mainWin = new Ktag();
        app.setMainWidget( mainWin );
	if(args->count() > 0){
		kdDebug("Main")<< args->arg(0) << endl;
		mainWin->setFile(args->arg(0));
	}
	else{
          QString fileName;
          fileName = KFileDialog::getOpenFileName(NULL, "*.mp3 *.ogg", 0, "Open audio file");
              QFileInfo file( fileName );
              if( file.exists() && !file.isDir() ){
                  mainWin->setFile(fileName);
              }
	      else{
	      	exit(0);
	      }
	}
	mainWin->readTags();
        mainWin->show();

        args->clear();

    // mainWin has WDestructiveClose flag by default, so it will delete itself.
    return app.exec();
}

